/* Copyright (C) 2004 - 2005  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
using System;
using System.IO;

using com.db4o;
using com.db4o.query;
using com.db4o.cluster;

namespace com.db4o.test
{
	/// <summary>
	/// Summary description for BasicClusterTest.
	/// </summary>
	public class BasicClusterTest
	{
        public String _name;
    
        public static String SECOND_FILE = "second.yap";
    
        public BasicClusterTest(){
        }
    
        public BasicClusterTest(String name){
            _name = name;
        }
    
        public void store(){
            File.Delete(SECOND_FILE);
            Tester.store(new BasicClusterTest("inOne"));
            Tester.store(new BasicClusterTest("inBoth"));
            ObjectContainer second = Db4o.openFile(SECOND_FILE);
            second.set(new BasicClusterTest("inBoth"));
            second.set(new BasicClusterTest("inTwo"));
            second.close();
        }
    
        public void test(){
            ObjectContainer second = Db4o.openFile(SECOND_FILE);
            Cluster cluster = new Cluster(new ObjectContainer[]{
                Tester.objectContainer(),
                second
            });
            tQuery(cluster, "inOne", 1);
            tQuery(cluster, "inTwo", 1);
            tQuery(cluster, "inBoth", 2);
            second.close();
        }
    
        private void tQuery(Cluster cluster, String name, int expected){
            Query q = cluster.query();
            q.constrain(this.GetType());
            q.descend("_name").constrain(name);
            System.Collections.IList list = q.execute();
            Tester.ensure(list.Count == expected);
            foreach( BasicClusterTest bct in list){
                Tester.ensure(bct._name.Equals(name));
            }

        }

	}
}
